function keysEnablementsStruct = Xil_RGB2YCrCb_enablement(blockHandle, keysValuesStruct)

%intially, construct the return value (keysEnablementsStruct) with
%all controls enabled

  keys = fieldnames(keysValuesStruct);
  for i = 1:length(keys)
    keysEnablementsStruct.(keys{i}) = 'on';
  end
  keysEnablementsStruct = xlmagicenablement(blockHandle, keysValuesStruct);

  %---now conditionally disable some controls---                                                         

  keysEnablementsStruct.('coefvoid') = 'off';
 
%  if strcmp(keysValuesStruct.('is_v4'), 'off')
%    keysEnablementsStruct.('fabric_adds') = 'off';
%  end
  if (strcmp(keysValuesStruct.('fabric_adds'), 'off'))
    keysEnablementsStruct.('m_bits') = 'off';
  end

  if strcmp(keysValuesStruct.('has_clip'), 'off')
    keysEnablementsStruct.('ymax') = 'off';                                                          
    keysEnablementsStruct.('cmax') = 'off';
  end
    
  if strcmp(keysValuesStruct.('has_clamp'), 'off') 
    keysEnablementsStruct.('ymax') = 'off';                                                          
    keysEnablementsStruct.('ymin') = 'off';
  end

  if (~(strcmp(keysValuesStruct.('standard'),'custom')))                    % Leaving 'custom'
    keysEnablementsStruct.('advancedtab') = 'off';  
  end

  if (~(keysValuesStruct.('standard')(2)=='C')) % Not a YCrCb conversion
    keysEnablementsStruct.('range_sel') = 'off';
  end
